<?php

// ========================== 文件说明 ==========================//
// 本文件说明：前台公共函数
// --------------------------------------------------------------//
// 本程序作者：angel
// --------------------------------------------------------------//
// 本程序版本：SaBlog-X Ver 1.6
// --------------------------------------------------------------//
// 本程序主页：http://www.sablog.net
// ========================== 开发环境 ==========================//
// register_globals = Off
// --------------------------------------------------------------//
// magic_quotes_gpc = On
// --------------------------------------------------------------//
// safe_mode = On
// --------------------------------------------------------------//
// Windows server 2003 & Linux & FreeBSD
// --------------------------------------------------------------//
// Apache/1.3.33 & PHP/4.3.2 & MySQL/4.0.17
// --------------------------------------------------------------//
// Apache/1.3.34 & PHP/4.4.1 & MySQL/5.0.16
// --------------------------------------------------------------//
// Apache/2.0.55 & PHP/5.1.1 & MySQL/5.0.15
// --------------------------------------------------------------//
// Copyright (C) Security Angel Team All Rights Reserved.
// ==============================================================//


/*
// Fix for IIS, which doesn't set REQUEST_URI
if ( empty( $_SERVER['REQUEST_URI'] ) ) {

	// IIS Mod-Rewrite
	if (isset($_SERVER['HTTP_X_ORIGINAL_URL'])) {
		$_SERVER['REQUEST_URI'] = $_SERVER['HTTP_X_ORIGINAL_URL'];
	}
	// IIS Isapi_Rewrite
	else if (isset($_SERVER['HTTP_X_REWRITE_URL'])) {
		$_SERVER['REQUEST_URI'] = $_SERVER['HTTP_X_REWRITE_URL'];
	}
	else {
		// If root then simulate that no script-name was specified
		if (empty($_SERVER['PATH_INFO']))
			$_SERVER['REQUEST_URI'] = substr($_SERVER['SCRIPT_NAME'], 0, strrpos($_SERVER['SCRIPT_NAME'], '/')) . '/';
		elseif ( $_SERVER['PATH_INFO'] == $_SERVER['SCRIPT_NAME'] )
			// Some IIS + PHP configurations puts the script-name in the path-info (No need to append it twice)
			$_SERVER['REQUEST_URI'] = $_SERVER['PATH_INFO'];
		else
			$_SERVER['REQUEST_URI'] = $_SERVER['SCRIPT_NAME'] . $_SERVER['PATH_INFO'];

		// Append the query string if it exists and isn't null
		if (isset($_SERVER['QUERY_STRING']) && !empty($_SERVER['QUERY_STRING'])) {
			$_SERVER['REQUEST_URI'] .= '?' . $_SERVER['QUERY_STRING'];
		}
	}
}
*/
// 加载公用函数
require_once('include/common.inc.php');
require_once(SABLOG_ROOT.'include/func/front.func.php');
require_once(SABLOG_ROOT.'include/func/permalink.func.php');

/*////////////////////////////////////////////////////////////////////////
$home_dir = dirname($php_self);
if (substr($home_dir, -1) != '/') {
	$home_dir = $home_dir.'/';
}
$request = str_replace($home_dir,'',$_SERVER['REQUEST_URI']);
$rewrite_rules = unserialize($options['permalink_rules']);
$i=0;
foreach ($rewrite_rules as $match => $query) {
	if (preg_match("!^$match!", $request, $matches) || preg_match("!^$match!", urldecode($request), $matches)) {
		$query = preg_replace("!^.+\?!", '', $query);
		$parms = explode('&', $query);
		$i++;
		foreach ($parms as $parm) {
			$frontlen = strrpos($parm, '=');
			$front    = substr($parm, 0, $frontlen);
			eval("$$front = \"$matches[$i]\";");
		}
		break;
	}
}
*/



// 检查模版
$t_dir = SABLOG_ROOT.'templates/'.$options['templatename'].'/';
if (!is_dir($t_dir)) {
	if (is_dir(SABLOG_ROOT.'templates/default')) {
		$options['templatename'] = 'default';
	} else {
		exit('Template Error: '.$t_dir.' is not a directory.');
	}
}

// 状态检查
if ($options['close']) {
	message(html_clean($options['close_note']),'');
}

// 检查浏览模式
$viewmode = $_GET['viewmode'] ? $_GET['viewmode'] : $_COOKIE['viewmode'];
$viewmode = in_array($viewmode, array('normal', 'list')) ? $viewmode : $options['viewmode'];
if (!in_array($_COOKIE['viewmode'], array('normal', 'list')) || $viewmode != $_COOKIE['viewmode']) {
	scookie('viewmode',$viewmode,525600);
}

// 获取时间，假如是WIN系统，一定要做范围的限制。否则.....
$setdate = intval($_GET['setdate']);
if ($setdate && strlen($setdate) == 6) {
	$setyear = substr($setdate,0,4);
	if ($setyear >= 2038 || $setyear <= 1970) {
		$setyear = sadate('Y');
		$setmonth = sadate('m');
		$start = $end = 0;
	} else {
		$setmonth = substr($setdate,-2);
		list($start, $end) = explode('-', gettimestamp($setyear,$setmonth));
	}
} else {
	$setyear = sadate('Y');
	$setmonth = sadate('m');
	$start = $end = 0;
}

// 查询按月归档
//$monthname = array('','January','February','March','April','May','June','July','August','September','October','November','December');
// 查询并生成日历
if ($options['show_calendar']) {
	$calendar = calendar($setyear,$setmonth);
	$prevmonth = getdatelink($calendar['prevmonth']);
	$nextmonth = getdatelink($calendar['nextmonth']);
}

/***
*处理一些数据以便直接应用到模板
**/

// 是否随机友情链接
if ($options['random_links']) {
	shuffle($linkcache);
}
// 显示一定数量的友情链接
$options['sidebarlink_num'] = intval($options['sidebarlink_num']);
if ($options['sidebarlink_num']) {
	$linkcache = array_slice($linkcache,0,$options['sidebarlink_num']);
}

// 设置永久连接
if ($options['permalink']) {
	$archives_url = $options['url'].'archives/';
	$search_url = $options['url'].'search/';
	$links_url = $options['url'].'links/';
	$reg_url = $options['url'].'register/';
	$login_url = $options['url'].'login/';
	$tagslist_url = $options['url'].'tagslist/';
	$comments_url = $options['url'].'comments/';
	$trackbacks_url = $options['url'].'trackbacks/';
} else {
	$archives_url = $options['url'].'?action=archives';
	$search_url = $options['url'].'?action=search';
	$links_url = $options['url'].'?action=links';
	$reg_url = $options['url'].'cp.php?action=register';
	$login_url = $options['url'].'cp.php?action=login';
	$tagslist_url = $options['url'].'?action=tagslist';
	$comments_url = $options['url'].'?action=comments';
	$trackbacks_url = $options['url'].'?action=trackbacks';
}

// 处理归档显示
if ($archivecache) {
	$tmp = $archivesdb = array();
	foreach($archivecache as $key => $value) {
		list($y, $m) = explode('-', $key);
		$key = $y.'年'.$m.'月';
		$tmp[$key] = $value;
		$archivesdb[$y.$m] = $value['num'];
	}
	$archivecache = $tmp;
	$tmp = array();
}

/***
*处理缓存数据结束
**/

$modelink = '';
if ($action) {
	$modelink .= '&amp;action='.$action;
}
if ($curl) {
	$modelink .= '&amp;curl='.$curl;
}
if ($cid) {
	$modelink .= '&amp;cid='.$cid;
}
if ($setdate) {
	$modelink .= '&amp;setdate='.$setdate;
}
if ($setday) {
	$modelink .= '&amp;setday='.$setday;
}
if (intval($_GET['searchid'])) {
	$modelink .= '&amp;searchid='.$_GET['searchid'];
}
if (intval($_GET['userid'])) {
	$modelink .= "&amp;userid=".$_GET['userid'];
}
if ($_GET['item']) {
	$item = urlencode(sax_addslashes($item));
	$modelink .= '&amp;item='.$item;
}

?>