<?php

// ========================== 文件说明 ==========================//
// 本文件说明：用户管理
// --------------------------------------------------------------//
// 本程序作者：angel
// --------------------------------------------------------------//
// 本程序版本：SaBlog-X Ver 1.6
// --------------------------------------------------------------//
// 本程序主页：http://www.sablog.net
// ========================== 开发环境 ==========================//
// register_globals = Off
// --------------------------------------------------------------//
// magic_quotes_gpc = On
// --------------------------------------------------------------//
// safe_mode = On
// --------------------------------------------------------------//
// Windows server 2003 & Linux & FreeBSD
// --------------------------------------------------------------//
// Apache/1.3.33 & PHP/4.3.2 & MySQL/4.0.17
// --------------------------------------------------------------//
// Apache/1.3.34 & PHP/4.4.1 & MySQL/5.0.16
// --------------------------------------------------------------//
// Apache/2.0.55 & PHP/5.1.1 & MySQL/5.0.15
// --------------------------------------------------------------//
// Copyright (C) Security Angel Team All Rights Reserved.
// ==============================================================//


if(!defined('SABLOG_ROOT') || !isset($php_self) || !preg_match("/[\/\\\\]cp\.php$/", $php_self)) {
	exit('Access Denied');
}

if ($sax_group == 1) {
	!$action && $action = 'list';
} else {
	!$action && $action = 'profile';
}

//权限检查
if (!in_array($action, array('profile','modprofile'))) {
	permission();
}


//添加用户

if($action == 'adduser') {
	$username       = trim($_POST['username']);
	$newpassword    = trim($_POST['newpassword']);
	$comfirpassword = trim($_POST['comfirpassword']);
	$email          = trim($_POST['email']);
	$url            = trim($_POST['url']);
	$groupid        = intval($_POST['groupid']);

	if (!$username || strlen($username) > 20) {
		redirect('登陆名不能为空并且不能超过20个字符');
    }
	$name_key = array("\\",'&',' ',"'",'"','/','*',',','<','>',"\r","\t","\n",'#','$','(',')','%','@','+','?',';','^');
	foreach($name_key as $value){
		if (strpos($username,$value) !== false){
			redirect('用户名包含敏感字符');
		}
	}
	if (!isemail($email)) {
		redirect('E-mail地址错误');
	}
	if (!checkurl($url)) {
		redirect('网站URL错误');
	}
    if ($newpassword == '' || strlen($newpassword) < 8) {
		redirect('密码不能为空并且密码长度不能小于8位');
	}
    if ($newpassword != $comfirpassword) {
        redirect('请确认输入的密码一致');
    }
	if (strpos($newpassword,"\n") !== false || strpos($password,"\r") !== false || strpos($password,"\t") !== false) {
		redirect('密码包含不可接受字符.');
	}
	$url = char_cv($url);
	$email = char_cv($email);
	$username = char_cv($username);
	$newpassword = md5($newpassword);

    $r = $DB->fetch_one_array("SELECT userid FROM {$db_prefix}users WHERE username='$username' LIMIT 1");
    if($r['userid']) {
		redirect('该用户名已被注册');
    }
    $r = $DB->fetch_one_array("SELECT userid FROM {$db_prefix}users WHERE email='$email' LIMIT 1");
    if($r['userid']) {
		redirect('该E-mail已被注册');
    }

	$DB->query("INSERT INTO {$db_prefix}users (username, password, email, url, regdateline, regip, groupid) VALUES ('$username', '$newpassword', '$email', '$url', '$timestamp', '$onlineip', '$groupid')");
    redirect('添加新用户成功', 'cp.php?job=user&action=list');

}

//修改用户

if($action == 'moduser') {	
	$username       = trim($_POST['username']);
	$newpassword    = trim($_POST['newpassword']);
	$comfirpassword = trim($_POST['comfirpassword']);
	$email          = trim($_POST['email']);
	$url            = trim($_POST['url']);
	$groupid        = intval($_POST['groupid']);
	$userid         = intval($_POST['userid']);
	if (!$username || strlen($username) > 20) {
		redirect('登陆名不能为空并且不能超过20个字符');
    }
	if (!isemail($email)) {
		redirect('E-mail地址错误');
	}
	if (!checkurl($url)) {
		redirect('网站URL错误');
	}
	$password_sql = '';
	if ($newpassword) {
		if(strlen($newpassword) < 8) {
			redirect('新密码长度不能小于8位');
		}
		if ($newpassword != $comfirpassword) {
			redirect('请确认输入的新密码一致');
		}
		if (strpos($newpassword,"\n") !== false || strpos($password,"\r") !== false || strpos($password,"\t") !== false) {
			redirect('密码包含不可接受字符');
		}
		$password_sql = ", password='".md5($newpassword)."'";
	}
	$name_key = array("\\",'&',' ',"'",'"','/','*',',','<','>',"\r","\t","\n",'#','$','(',')','%','@','+','?',';','^');
	foreach($name_key as $value){
		if (strpos($username,$value) !== false){
			redirect('用户名包含敏感字符');
		}
	}
	$url = char_cv($url);
	$username = char_cv($username);
    $r = $DB->fetch_one_array("SELECT userid FROM {$db_prefix}users WHERE username='$username' AND userid!='$userid' LIMIT 1");
    if($r) {
		redirect('该用户名已被注册');
    }

	$usernamesql = $username ? "username='$username'," : '';
    $DB->unbuffered_query("UPDATE {$db_prefix}users SET $usernamesql url='$url', email='$email', groupid='$groupid' $password_sql WHERE userid='$userid'");
    redirect('用户修改成功','cp.php?job=user&action=mod&userid='.$userid);

}

//修改个人资料
if ($action == 'modprofile') {
	$username        = trim($_POST['username']);
	$old_password    = md5($_POST['old_password']);
	$password        = $_POST['password'];
	$confirmpassword = $_POST['confirmpassword'];
	$email             = trim($_POST['email']);
	$url             = trim($_POST['url']);
	$referer         = trim($_POST['referer']);

	if (!checkurl($url)) {
		redirect('网站URL错误');
	}
	if (!isemail($email)) {
		redirect('E-mail地址错误');
	}
	//修改资料
	$password_sql = '';
	if ($password) {
		$user = $DB->fetch_one_array("SELECT password FROM {$db_prefix}users WHERE userid='$sax_uid'");
		if (!$user) {
			redirect('出错,请尝试重新登陆再进行此操作');
		}
		if ($old_password != $user['password']) {
			redirect('密码无效');
		}
		if(strlen($password) < 8) {
			redirect('新密码长度不能小于8位');
		}
		if ($password != $confirmpassword) {
			redirect('请确认输入的新密码一致');
		}
		if (strpos($password,"\n") !== false || strpos($password,"\r") !== false || strpos($password,"\t") !== false) {
			redirect('密码包含不可接受字符');
		}
		$password_sql = ", password='".md5($password)."'";
	}

	$email = char_cv($email);
	$url = char_cv($url);
	$DB->unbuffered_query("UPDATE {$db_prefix}users SET url='$url', email='$email' $password_sql WHERE userid='$sax_uid'");
	if ($password) {
		dcookies();
		redirect('资料已修改成功,您修改了密码,需要重新登陆.', $login_url);
	} else {
		redirect('资料已修改成功.', $options['url'].'cp.php?job=user&action=profile');
	}

}

//删除用户
if($action == 'delusers') {	
	if ($uids = implode_ids($_POST['user'])) {
		$user_count = count($_POST['user']);	
		if ($_POST['deluserarticle']) {
			$aids = $a_tatol = 0;
			// 删除该用户发表的文章以及相关数据
			require_once(SABLOG_ROOT.'include/func/attachment.func.php');
			$query = $DB->query("SELECT articleid,keywords,visible,cid FROM {$db_prefix}articles WHERE uid IN ($uids)");
			while ($article = $DB->fetch_array($query)) {
				if ($article['keywords']) {
					updatetags($article['articleid'], '', $article['keywords']);
				}
				if ($article['visible']) {
					$a_tatol++;
					$DB->unbuffered_query("UPDATE {$db_prefix}categories SET articles=articles-1 WHERE cid='".$article['cid']."'");
				}
				$aids .= ','.$article['articleid'];
			}//end while
			
			// 删除该用户的文章中的附件
			$query  = $DB->query("SELECT attachmentid,filepath,thumb_filepath FROM {$db_prefix}attachments WHERE articleid IN ($aids)");
			$nokeep = array();
			while($attach = $DB->fetch_array($query)) {
				$nokeep[$attach['attachmentid']] = $attach;
			}
			removeattachment($nokeep);

			$DB->unbuffered_query("DELETE FROM {$db_prefix}comments WHERE articleid IN ($aids)");
			$DB->unbuffered_query("DELETE FROM {$db_prefix}trackbacks WHERE articleid IN ($aids)");
			$DB->unbuffered_query("DELETE FROM {$db_prefix}trackbacklog WHERE articleid IN ($aids)");
			$DB->unbuffered_query("DELETE FROM {$db_prefix}articles WHERE uid IN ($uids)");
			$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET article_count=article_count-".$a_tatol);
		}
		// 删除用户
		$DB->unbuffered_query("DELETE FROM {$db_prefix}users WHERE userid IN ($uids)");
		$DB->unbuffered_query("UPDATE {$db_prefix}statistics SET user_count=user_count-".$user_count);

		archives_recache();
		categories_recache();
		statistics_recache();
		redirect('删除用户成功', 'cp.php?job=user&action=list');
	} else {		
		redirect('未选择任何用户');
	}
}

if($action == 'list') {
	$pagenum = 20;
	if($page) {
		$start_limit = ($page - 1) * $pagenum;
	} else {
		$start_limit = 0;
		$page = 1;
	}
	$subnav = '全部用户';
	$sqladd = ' WHERE 1 ';
	$pagelink = '';

	//察看用户组
	if ($groupid && in_array($groupid, array(1,2,3,4))) {
		echo 'ssssss';
		$sqladd .= " AND groupid='$groupid'";
		$pagelink .= '&groupid='.$groupid;
		$subnav = $groupdb[$groupid].'的用户';
	}

	//搜索用户
	$srhname = char_cv($_GET['srhname'] ? $_GET['srhname'] : $_POST['srhname']);
	if ($srhname) {
		$sqladd .= " AND (BINARY username LIKE '%".str_replace('_', '\_', $srhname)."%' OR username='$srhname')";
		$pagelink .= '&srhname='.$srhname;
	}

	//字段
	if ($field && in_array($field, array('username','logincount','regdateline','lastpost'))) {
		$orderdb = array('userid'=>'用户ID','username'=>'用户名','logincount'=>'登陆次数','regdateline'=>'注册时间','lastpost'=>'最后评论时间');
		$subnav = '以'.$orderdb[$field].'察看全部用户';
		$pagelink .= '&field='.$field;
	} else {
		$field = 'userid';
	}

	//顺序
	if ($order && in_array($order, array('desc','asc'))) {
		$orderdb = array('desc'=>'降序','asc'=>'升序');
		$subnav .= '['.$orderdb[$order].']';
		$pagelink .= '&order='.$order;
	} else {
		$subnav .= '[降序]';
		$order = 'desc';
	}

	$tatol     = $DB->result($DB->query("SELECT COUNT(*) FROM {$db_prefix}users ".$sqladd), 0);
	$multipage = multi($tatol, $pagenum, $page, 'cp.php?job=user&action=list'.$pagelink);
	$query = $DB->query("SELECT userid,email,username,lastip,url,regdateline,regip,groupid,lastvisit FROM {$db_prefix}users $sqladd ORDER BY $field $order LIMIT $start_limit, $pagenum");
	$userdb = array();

	while ($user = $DB->fetch_array($query)) {
		$user['regdateline']	= sadate('Y-m-d',$user['regdateline']);
		$user['lastvisit']		= $user['lastvisit'] ? sadate('Y-m-d',$user['lastvisit']) : '<font color="#FF0000">Null</font>';
		$user['email']			= $user['email'] ? $user['email'] : '<font color="#FF0000">Null</font>';
		$user['url']			= $user['url'] ? '<a href="'.$user['url'].'" target="_blank">访问主页</a>' : '<font color="#FF0000">Null</font>';
		$user['lastip']			= $user['lastip'] ? $user['lastip'] : '从未登陆';
		$user['group']			= $groupdb[$user['groupid']];
		$user['disabled']		= ($user['groupid'] == 1 || $user['userid'] == 1) ? 'disabled' : '';
		$userdb[] = $user;
	}
	unset($user);
	$DB->free_result($query);
} //end list


if (in_array($action, array('add', 'mod', 'profile'))) {
	$info = array();

	if ($action == 'add') {
		$subnav = '添加用户';
		$do = 'adduser';
		$groupselect[3] = 'selected';
	} else {
		$subnav = '修改资料';
		if ($action == 'profile') {
			$do = 'modprofile';
			$info = $DB->fetch_one_array("SELECT * FROM {$db_prefix}users WHERE userid='$sax_uid'");
		} else {
			$do = 'moduser';
			$userid = intval($_GET['userid']);
			$info = $DB->fetch_one_array("SELECT * FROM {$db_prefix}users WHERE userid='$userid'");
			$groupselect[$info['groupid']] = 'selected';
		}

		$info['regdateline'] = sadate('Y-m-d H:i', $info['regdateline']);
		$info['lastpost'] = $info['lastpost'] ? sadate('Y-m-d H:i', $info['lastpost']) : '从未';
		$info['lastvisit'] = $info['lastvisit'] ? sadate('Y-m-d H:i', $info['lastvisit']) : '从未';
		$info['lastactivity'] = $info['lastactivity'] ? sadate('Y-m-d H:i', $info['lastactivity']) : '从未';
	}

} //end mod





if($action == 'del') {
	if ($uids = implode_ids($_POST['user'])) {
		$userdb = array();
		$query = $DB->query("SELECT userid,username FROM {$db_prefix}users WHERE userid IN ($uids) AND groupid <> '1' AND userid <> '1'");
		while ($user = $DB->fetch_array($query))	{ 
			$userdb[] = $user;
		}
		unset($user);
		$DB->free_result($query);
	} else {		
		redirect('未选择任何用户');
	}
	$subnav = '删除用户';
}// end del


$navlink_L = ' &raquo; <a href="cp.php?job=user">用户管理</a>'.($subnav ? ' &raquo; '.$subnav : '');
cpheader($subnav);
include template('user');

?>